
#include "Rectangle_dlg.h"
#include <math.h>
#include <qmessagebox.h>


void Form5::On_Quit_clicked()
{
    close();
}

void Form5::On_generate_clicked()
{
QString cstr, cstr2;
double   X_start, Y_start, inter_pos_feed, cutting_feed;
double   Z_boring_feed, Z_inter_pos_height, Z_bore_depth, Z_start_height, Z_decrement;
double   cutter_diameter,  spindle_speed, X_length, Y_length, cuts, loops;
double   subXstart, subYstart, subXlen, subYlen;
int     linenum = 1;
int     block_start, block_end, f;
bool    b_coolant, b_Xneg, b_Yneg;



    // get data from line edits

    X_start = ((QString)le_X_start->text()).toDouble();
    Y_start = ((QString)le_Y_start->text()).toDouble();
    X_length = ((QString)le_X_length->text()).toDouble();
    Y_length = ((QString)le_Y_length->text()).toDouble();  
    inter_pos_feed = ((QString)le_inter_position_feed->text()).toDouble();
    Z_boring_feed =  ((QString)le_Z_boring_feed->text()).toDouble();  
    Z_inter_pos_height = ((QString)le_Z_inter_position_height->text()).toDouble();
    Z_bore_depth = ((QString)le_Z_bore_depth->text()).toDouble();
    if(Z_bore_depth < 0)
        Z_bore_depth = Z_bore_depth * -1;   // make sure not neg number
    Z_start_height = ((QString)le_Z_start_height->text()).toDouble();
    Z_decrement = ((QString)le_Z_decrement->text()).toDouble();
    cutter_diameter = ((QString)le_cutter_diameter->text()).toDouble();
    cutting_feed  = ((QString)le_cutting_feed->text()).toDouble();
    spindle_speed = ((QString)le_spindle_speed->text()).toDouble();
    

    block_start = block_end = 0; 
    f = 0;
    b_Xneg = b_Yneg = false;

    b_coolant = cb_coolant->isChecked();

    cuts = floor(Z_bore_depth / Z_decrement);

    if((cuts * Z_decrement) != Z_bore_depth)
        {
        QMessageBox::information(this, "EASIMILL - Rectangle Milling generator",
            "Z decrement does not divide equally into required Z final depth\n"
            "Will be rounded down so may not break through or reach required depth\n"
            "For exact depth, substitute for a figure that will divide equally");
        }

    // Set initial figures
    if(X_length < 0) b_Xneg = true;
    if(Y_length < 0) b_Yneg = true;
    if(X_length < 0) X_length = X_length * -1;
    if(Y_length < 0) Y_length = Y_length * -1;

    if(X_start < 0 || Y_start < 0)
        {
        QMessageBox::information(this, "EASIMILL - Rectangle Milling generator",
            "X and Y start co-ordinates can be Zero or a positive offset\n"
            "If you want to start at a negative offset, change your G55 offsets accordingly");
        return;
        }

    loops = ceil(Y_length / (cutter_diameter * 2)); // makes forward & reverse pass so double width

    subXstart = X_start + (cutter_diameter / 2);
    subXlen = X_length - cutter_diameter;
    subYstart = Y_start + (cutter_diameter / 2);
    subYlen = Y_length - cutter_diameter;

    ///////   start strings

    cstr.sprintf("N%d M3 S%.0f \n",linenum++, spindle_speed);
    te_gcode->setText(cstr);

    b_Xneg ? cstr.sprintf("N%d G01 X-%.3f ",linenum++ , subXstart) : cstr.sprintf("N%d G01 X%.3f ",linenum++ , subXstart);
    b_Yneg ? cstr += cstr2.sprintf("Y-%.3f FX%.0f Z%.3f FZ%.0f\n", subYstart ,  inter_pos_feed, Z_start_height, inter_pos_feed) : 
             cstr += cstr2.sprintf("Y%.3f FX%.0f Z%.3f FZ%.0f\n", subYstart ,  inter_pos_feed, Z_start_height, inter_pos_feed);
    te_gcode->append(cstr);

    cstr.sprintf("N%d G01 Z%.3f FZ%.0f\n",linenum++ , Z_inter_pos_height, inter_pos_feed);
    te_gcode->append(cstr);
    
    if(b_coolant)
        {
        cstr.sprintf("N%d M8\n", linenum++);
        te_gcode->append(cstr);
        }    
        
    block_start = linenum;

    // First line of block must contain co-ordinates for all axes as machine returns to this position
    // at every iteration +/- offsets in G81 block
    
    b_Xneg ? cstr.sprintf("N%d G01 X-%.3f ",linenum++ , subXstart) : cstr.sprintf("N%d G01 X%.3f ",linenum++ , subXstart);
    b_Yneg ? cstr += cstr2.sprintf("Y-%.3f FX%.0f Z-%.3f FZ%.0f\n", subYstart , cutting_feed, Z_decrement , Z_boring_feed) : 
             cstr += cstr2.sprintf("Y%.3f FX%.0f Z-%.3f FZ%.0f\n", subYstart , cutting_feed, Z_decrement , Z_boring_feed);
    te_gcode->append(cstr);

    b_Xneg ? cstr.sprintf("N%d G01 X-%.3f FX%.0f\n",linenum++ , subXstart + subXlen, cutting_feed) : 
             cstr.sprintf("N%d G01 X%.3f FX%.0f\n",linenum++ , subXstart + subXlen, cutting_feed);
    te_gcode->append(cstr);
    
    b_Yneg ? cstr.sprintf("N%d G01 Y-%.3f FX%.0f\n",linenum++ , subYstart + subYlen , cutting_feed) : 
             cstr.sprintf("N%d G01 Y%.3f FX%.0f\n",linenum++ , subYstart + subYlen, cutting_feed);
    te_gcode->append(cstr);

    b_Xneg ? cstr.sprintf("N%d G01 X-%.3f FX%.0f\n",linenum++ , subXstart, cutting_feed) : 
             cstr.sprintf("N%d G01 X%.3f FX%.0f\n",linenum++ , subXstart, cutting_feed);
    te_gcode->append(cstr);

    b_Yneg ? cstr.sprintf("N%d G01 Y-%.3f FX%.0f\n",linenum++ , subYstart , cutting_feed) : 
             cstr.sprintf("N%d G01 Y%.3f FX%.0f\n",linenum++ , subYstart, cutting_feed);
    te_gcode->append(cstr);
   
    subXstart += (cutter_diameter - 1);
    subXlen -= (cutter_diameter * 2) - 1;
    subYstart += (cutter_diameter - 1);
    subYlen -= (cutter_diameter * 2) - 1;
    loops--;
    while(loops > 0)
        {
        b_Xneg ? cstr.sprintf("N%d G01 X-%.3f ",linenum++ , subXstart) : cstr.sprintf("N%d G01 X%.3f ",linenum++ , subXstart);
        b_Yneg ? cstr += cstr2.sprintf("Y-%.3f FX%.0f Z-%.3f FZ%.0f\n", subYstart , cutting_feed, Z_decrement , Z_boring_feed) : 
                 cstr += cstr2.sprintf("Y%.3f FX%.0f Z-%.3f FZ%.0f\n", subYstart , cutting_feed, Z_decrement , Z_boring_feed);
        te_gcode->append(cstr);

        b_Xneg ? cstr.sprintf("N%d G01 X-%.3f FX%.0f\n",linenum++ , subXstart + subXlen, cutting_feed) : 
                 cstr.sprintf("N%d G01 X%.3f FX%.0f\n",linenum++ , subXstart + subXlen, cutting_feed);
        te_gcode->append(cstr);
    
        b_Yneg ? cstr.sprintf("N%d G01 Y-%.3f FX%.0f\n",linenum++ , subYstart + subYlen , cutting_feed) : 
                 cstr.sprintf("N%d G01 Y%.3f FX%.0f\n",linenum++ , subYstart + subYlen, cutting_feed);
        te_gcode->append(cstr);
    
        b_Xneg ? cstr.sprintf("N%d G01 X-%.3f FX%.0f\n",linenum++ , subXstart, cutting_feed) : 
                 cstr.sprintf("N%d G01 X%.3f FX%.0f\n",linenum++ , subXstart, cutting_feed);
        te_gcode->append(cstr);

        b_Yneg ? cstr.sprintf("N%d G01 Y-%.3f FX%.0f\n",linenum++ , subYstart , cutting_feed) : 
                 cstr.sprintf("N%d G01 Y%.3f FX%.0f\n",linenum++ , subYstart, cutting_feed);
        te_gcode->append(cstr);
        
        subXstart += (cutter_diameter - 1);
        subXlen -= (cutter_diameter * 2) - 1;
        subYstart += (cutter_diameter - 1);
        subYlen -= (cutter_diameter * 2) - 1;
        loops--;
        }// end while


    // once the piece left is smaller than the cutter, move cutter along X axis to remove it
    b_Xneg ? cstr.sprintf("N%d G01 X-%.3f ",linenum++ , subXstart) : cstr.sprintf("N%d G01 X%.3f ",linenum++ , subXstart);
    b_Yneg ? cstr += cstr2.sprintf("Y-%.3f FX%.0f Z-%.3f FZ%.0f\n", subYstart , cutting_feed, Z_decrement , Z_boring_feed) : 
             cstr += cstr2.sprintf("Y%.3f FX%.0f Z-%.3f FZ%.0f\n", subYstart , cutting_feed, Z_decrement , Z_boring_feed);
    te_gcode->append(cstr);

    b_Xneg ? cstr.sprintf("N%d G01 X-%.3f FX%.0f\n",linenum++ , subXstart + subXlen, cutting_feed) : 
             cstr.sprintf("N%d G01 X%.3f FX%.0f\n",linenum++ , subXstart + subXlen, cutting_feed);
    te_gcode->append(cstr);
 
    block_end = linenum - 1;  // prevent an error if only one cut cycle is required - setting N to 0 throws error
     if((cuts - 1) > 0)
        {
        cstr.sprintf("N%d G81 R%d E%d N%.0f X0 Y0 Z-%.3f FZ%.0f\n",linenum++, block_start, block_end, cuts -1, Z_decrement, Z_boring_feed);
        te_gcode->append(cstr);
        }

  ////////////    end strings

    cstr.sprintf("N%d G00 Z%.3f\n" , linenum++, Z_start_height);
    te_gcode->append(cstr);
    if(b_coolant)
        {
        cstr.sprintf("N%d M9\n", linenum++);
        te_gcode->append(cstr);
        }    
    cstr.sprintf("N%d M5\nM2\n", linenum++ ); 
    te_gcode->append(cstr);

    te_gcode->selectAll(true);
    te_gcode->copy();

    cstr.sprintf("\n\nThis code is now in the clipboard\n\n");
    te_gcode->append(cstr);   
}



